from flask import Flask, request, abort
import instaloader
from instaloader.exceptions import ProfileNotExistsException
from pathlib import Path
import os
import shutil


app = Flask(__name__)


@app.route('/username=<username>', methods=['GET'])
def webhook(username):
    if request.method == 'GET':
        ig = instaloader.Instaloader()
        ig.login(os.environ.get('USER'), os.environ.get('PASSWORD'))
        try:
            ig.download_profile(username, profile_pic_only=True)
        except ProfileNotExistsException:
            return "error: Profile not exist", 404
        else:
            files = Path(username).glob('*')

            for file in files:
                file_name = str(file)
                file_type = file_name[-4:]
                if file_type == ".jpg":
                    os.replace(f"{file_name}", "profile.jpg")
                    shutil.rmtree(username)
                    os.replace("profile.jpg", f"profile_pics/{username}.jpg")

            return 'success', 200

    else:
        abort(400)


if __name__ == '__main__':
    app.run(port=5000)
